//+------------------------------------------------------------------+
//|                                               457908-2dArray.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <Trade\Trade.mqh>

input double Points = 500;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+

#define def_cols           5
#define def_ticketNo       0
#define def_OpenPrice      1
#define def_LotSize        2
#define def_NextDayPrice   3
#define def_SetNewPrice    4
double MyArray [][def_cols];

//+------------------------------------------------------------------+
//| General program Input function                                   |
//+------------------------------------------------------------------+
input int    RSI_Period    = 14;        // RSI Period
input ENUM_TIMEFRAMES RSI_Timeframe=PERIOD_CURRENT;
input double Overbought   = 70;        // RSI Overbought level
input double Oversold     = 30;        // RSI Oversold level
input double LotSize      = 0.05;       // Lot size
input double StopLoss     = 0;        // Stop loss in pips
input double TakeProfit   = 1000;       // Take profit in pips

double rsiArray[];
int rsiValue;
CTrade trade;

int    LastRow = ArrayResize(MyArray, 1) - 1;   // Start with first row [0]

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   // Add any necessary initialization code here
      rsiValue = iRSI(_Symbol,_Period, RSI_Period, PRICE_CLOSE);
      ArraySetAsSeries(rsiArray,true);
      //CopyBuffer(rsiValue,0,0,3,rsiArray);
      
   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   // Clean up and deinitialization code here
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
    //int rsiValue = iRSI(_Symbol,_Period, RSI_Period, PRICE_CLOSE);
    //ArraySetAsSeries(rsiArray,true);
    CopyBuffer(rsiValue,0,0,3,rsiArray);
    
    CheckRunningTrades();
        
    if(PositionsTotal() < 1)
    { 
      trade();  
    }
   //if(PositionsTotal() > 1)
   //{
      //CheckRunningTrades();
      //trade2();
      
      //UpdateAverageInfo();
   //}
  }
  
//+------------------------------------------------------------------+
//| Take Trades Function 1                                           |
//+------------------------------------------------------------------+

void trade()
   {
      double MyRsiValue = NormalizeDouble(rsiArray[0],2);
      Comment(MyRsiValue);
      if (MyRsiValue >= Overbought)
        {
         // Implement your overbought trading logic here
         // For example, you can open a sell trade
         // OrderSend(Symbol(), OP_SELL, LotSize, Ask, 3, 0, 0, "", 0, clrNONE);
         double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
         double Sl = StopLoss==0 ? 0 : Bid + StopLoss * _Point;
         double Tp = Bid - TakeProfit * _Point;
         
         trade.Sell(LotSize,_Symbol,Bid,Sl,Tp);
        }
      else if (MyRsiValue <= Oversold)
        {
         // Implement your oversold trading logic here
         // For example, you can open a buy trade
         // OrderSend(Symbol(), OP_BUY, LotSize, Bid, 3, 0, 0, "", 0, clrNONE);
         double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
         double Sl = StopLoss==0 ? 0 : Ask - StopLoss * _Point;
         double Tp = Ask + TakeProfit * _Point;
         
         trade.Buy(LotSize,_Symbol,Ask,Sl,Tp);
        }
         if(PositionsTotal() >1)
         {  
                 int totalPositions = PositionsTotal(); // Get the total number of open positions
         
                 // Iterate through all open positions to get their information
                 for (int i = 0; i < totalPositions; i++)
                 {
                    ulong ticket= PositionGetTicket(i);
                    double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
          
                 if (PositionSelectByTicket(ticket) == POSITION_TYPE_BUY && Ask <= def_SetNewPrice)
                 {   
                     double Sl = StopLoss==0 ? 0 : Ask - StopLoss * _Point;
                     double Tp = Ask + TakeProfit * _Point;
          
                     if(trade.Buy(LotSize,_Symbol,Ask,Sl,Tp))
                     {
                        MyArray[LastRow][def_SetNewPrice] = true;
                     }
                     
                 }
                 double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
         
                 if (PositionSelectByTicket(ticket) == POSITION_TYPE_SELL && Bid <= MyArray[LastRow][def_NextDayPrice])
                 { 
                     double Sl = StopLoss==0 ? 0 : Bid + StopLoss * _Point;
                     double Tp = Bid - TakeProfit * _Point;
         
                     if(trade.Sell(LotSize,_Symbol,Bid,Sl,Tp))   
                     {
                        MyArray[LastRow][def_SetNewPrice] = true;
                     }
                 }
                 if(PositionsTotal() >= 2)             
                  { 
                    double NewTakeProfit = NormalizeDouble(positionInfo[0][2] + TakeProfit *_Point,_Digits);
                    //double NewTakeProfit = positionInfo[0][2] + TakeProfit;
                    trade.PositionModify(ticket,0,NewTakeProfit);
                  }
   }
    }
      
}

  
//+------------------------------------------------------------------+
//| Trade Take Profit Modify                                           |
//+------------------------------------------------------------------+

/*void tradeModify()
{
  if(PositionsTotal() >= 2)             
   { 
     double NewTakeProfit = NormalizeDouble(positionInfo[0][2] + TakeProfit *_Point,_Digits);
     //double NewTakeProfit = positionInfo[0][2] + TakeProfit;
     trade.PositionModify(ticket,0,NewTakeProfit);
   }  
}*/
//+------------------------------------------------------------------+
//| Check Running Trades Function                                    |
//+------------------------------------------------------------------+

void CheckRunningTrades()
{    
   int totalPositions = PositionsTotal(); // Get the total number of open positions
         
         // Iterate through all open positions to get their information
          for (int i = 0; i < totalPositions; i++)
          {
              ulong ticket= PositionGetTicket(i);
          
              if (PositionSelectByTicket(ticket)) // Select the position by its ticket
              {
                  double openPrice = PositionGetDouble(POSITION_PRICE_OPEN);
                  double lotSize = PositionGetDouble(POSITION_VOLUME);
                  double newPrice = NormalizeDouble(openPrice - Points *_Point,_Digits);
          
                  MyArray[LastRow][def_ticketNo]      = (double)ticket;
                  MyArray[LastRow][def_OpenPrice]     = openPrice;
                  MyArray[LastRow][def_LotSize]       = lotSize;
                  MyArray[LastRow][def_NextDayPrice]  = newPrice;
                  MyArray[LastRow][def_SetNewPrice]  = false;
         
                  LastRow = ArrayResize(MyArray, (ArraySize(MyArray)/def_cols) +1) - 1; //Increase rows by 1 [Note ArraySize() returns number of cells so divide by cols to get rows]
                  Comment(newPrice);
                     
               
         
                 ArrayPrint(MyArray);
                 UpdateAverageInfo();
                 
                                  
               //  double NewTakeProfit = NormalizeDouble(positionInfo[0][2] + TakeProfit *_Point,_Digits);
                 //double NewTakeProfit = positionInfo[0][2] + TakeProfit;
                 
                 //trade.PositionModify(ticket,0,NewTakeProfit);  
            }
       } 
}          

//+------------------------------------------------------------------+
//| Check for New Bar Function                                       |
//+------------------------------------------------------------------+

bool IsNewBar()
            {
            bool isnewbar;
            static datetime timestamp;
            datetime time= timestamp;
            timestamp= (datetime) SeriesInfoInteger(Symbol(),PERIOD_H1,SERIES_LASTBAR_DATE);
         // long time= SeriesInfoInteger(SymbolArray[symbolloop],PERIOD_CURRENT,SERIES_LASTBAR_DATE);
            if(time != timestamp)
              {
               isnewbar=true;
               time=timestamp;
              }
            else
              {
               isnewbar=false;
              }
            return (isnewbar);
           }



//+------------------------------------------------------------------+
//| Update Average Price Function                                    |
//+------------------------------------------------------------------+

// Define the maximum number of open positions
#define MAX_POSITIONS5 20

// Define the number of parameters associated with each position
#define NUM_PARAMETERS5 4  // 0: Total Positions, 1: Open Prices, 2: Total Price

// Declare a two-dimensional array to store position information
double positionInfo[MAX_POSITIONS5][NUM_PARAMETERS5];

// Function to update position information
void UpdateAverageInfo()
{
    int totalPositions = PositionsTotal(); // Get the total number of open positions
    int openPositions = 0;  // Counter for open positions
    double totalPrice = 0.0;  // Variable to store the total price

    // Iterate through all open positions to get their information
    for (int i = 0; i < totalPositions; i++)
    {
        ulong ticket= PositionGetTicket(i);
    
        if (PositionSelectByTicket(ticket)) // Select the position by its ticket
        {
            double openPrice = PositionGetDouble(POSITION_PRICE_OPEN);
            double lotSize1 = PositionGetDouble(POSITION_VOLUME);
            positionInfo[openPositions][0] = openPositions + 1;  // Store position number
            positionInfo[openPositions][1] = openPrice;   // Store open price
            totalPrice += openPrice;  // Update total price
            openPositions++;
        }
        else
        {
            Print("Error selecting position with ticket ", i, ". Error code: ", GetLastError());
        }
    }

    // Update the total number of open positions
    positionInfo[0][0] = openPositions;

    // Calculate average price
    if (openPositions > 0)
    {
        positionInfo[0][2] = totalPrice/openPositions;
        Print("Average Price: ", positionInfo[0][2]);
    }
    else
    {
        positionInfo[0][2] = 0.0;
        Print("No open positions to calculate average price.");
    }
  
}



//+------------------------------------------------------------------+
//| New Trade Function                                               |
//+------------------------------------------------------------------+
/*void Tradetwo ()
{
   double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
          
   //if(PositionGetInteger(POSITION_TYPE_BUY) && Ask <= MyArray[LastRow][def_NextDayPrice])
         { 
            //trade.Buy(LotSize,_Symbol,Ask,0,0);   
         }
}
*/


//+------------------------------------------------------------------+
//| Calculate Take Profit Buys                                       |
//+------------------------------------------------------------------+
 

